<!--
/*
 *	Wyskakujący kalendarz
 *
 *	autor: Andrzej Cieślak (andrzej.cieslak@gazeta.pl)
 *	wersja: 1.1
 *	działa pod: IE, Opera, Firefox
 *
 *	opis:
 *	Po kliknięciu na pole tekstowe pojawia się kalendarz pod 
 *	kursorem myszy. Po wybraniu roku, miesiąca i kliknięciu na 
 *	numerze dnia wybrana data jest wstawiana do pola
 *
 *	historia:
 *	potrzebowałem wstawić datę do formularza w określonym formacie, 
 *	widziałem skrypt na necie który pozwalał wybrać datę z kalendarza, 
 *	ale był duży i skomplikowany, więc napisałem swój.
 *
 *	wywołanie:
 *	umieścić w zanczniku body: onLoad="document.onmousemove = mysz;" 
 *	lub w treści strony w znacznikach javascriptu: document.onmousemove = mysz;
 *	W polu tekstowym, do którego chcemy wstawić datę: onclick="showKal(this)"
 *	W kalendarzu można zmienić kolory, rok początkowy, rok końcowy, format
 *	wstawianej daty i dzień tygodnia od jakiego ma się zaczynać kalendarz.    
 *
 *	Zmiany:
 *	20.05.2008 - możliwość definiowania pierwszego dnia tygodnia w kalendarzu
 *
 */

var ie4, ns4, ns6;
var frmpole;
ie = document.all;
ns4 = document.layers;
ns6 = document.getElementById && !document.all;

// Aktualne data w kalendarzu
var data = new Date();
var amies = data.getMonth();
var arok = data.getFullYear();
var adzien = data.getDate();
var adzientyg = data.getDay();

// ilość dni w roku
var dni = new Array(31,28,31,30,31,30,31,31,30,31,30,31);
// nazwy miesięcy
var miesiac = new Array('Styczeń','Luty','Marzec','Kwiecień', 'Maj','Czerwiec','Lipiec','Sierpień','Wrzesień','Październik','Listopad','Grudzień');
// dni tygodnia
var dniTygodnia = new Array('Nd','Pn','Wt','Śr','Czw','Pt','So')

/************************* KONFIGURACJA *************************/

// pierwszy dzień tygodnia pokazywany w kalendarzu: 0 - niedziela, 1 - poniedziałek, 2 - wtorek, itd..
var pierwszyDzien = 0;

// dane kolorów
var kol = new Array(5)
kol[0] = '#ffffff'; // kolor tła kalendarza, kolor tekstu wybranego dnia, nazw dni tyg...
kol[1] = '#efefef'; // kolor pól kalendarza - dni zwykłe
kol[2] = '#FFDBDB'; // kolor pól kalendarza - niedziele
kol[3] = '#999999'; // kolor pola oznaczającego aktualny dzień, kolor ramki, przycisku zamykajacego, tekstu
kol[4] = '#999999'; // kolor pól okreslajacych dni tygodnia (pn,wt...)

// rok początkowy i rok końcowy pokazywany w polu wyboru
var rokOd = 2006;
var rokDo = 2012;

/************************* KONIEC KONFIGURACJI *************************/

// ilość dni w Lutym - przeliczane po zmianie miesiąca lub roku
function dniMies()
{
	dni[1] = (rok % 4 == 0) ? 29 : 28;
}

// pobieranie pozycji myszy
function mysz(e)
{
	var posx = 0;
	var posy = 0;
	if (!e) var e = window.event;
	if (e.pageX || e.pageY) 	{
		posx = e.pageX;
		posy = e.pageY;
	} else if (e.clientX || e.clientY) 	{
		posx = e.clientX + document.body.scrollLeft + document.documentElement.scrollLeft;
		posy = e.clientY + document.body.scrollTop + document.documentElement.scrollTop;
	}

  x = posx;
  y = posy;
}

// funkcja pokazujaca kalendarz pod kursorem myszy
function showKal(fp)
{
	data = new Date(arok, amies, 1);
	mies = data.getMonth();
	rok = data.getFullYear();
	dzien = data.getDate();
	dzientyg = data.getDay();
	
	dniMies();

	frmpole = fp;
	pozx = x;
	pozy = y;

	rysujKal();		
	
	if(ns6 || ie)
	{
		document.getElementById('kalendarz').style.left = pozx+'px';
		document.getElementById('kalendarz').style.top = (pozy+10)+'px';
		document.getElementById('kalendarz').style.visibility = 'visible';
	}
}

// funkcja ukrywajaca kalendarz i wstawiajaca wybraną datę do pola formularza
function hideKal()
{
	if(ns6 || ie)
		document.getElementById('kalendarz').style.visibility = 'hidden';

	// uwzględnienie zer poprzedzających w miesiącu i dniu
	mies++;
	if(mies < 10)
		mies = '0' + mies;
	if(selectday < 10)
		selectday = '0' + selectday;

/************************* FORMAT DATY *************************/
	// Przykłady:
	// format = selectday + ' ' + miesiac[mies] + ' ' + rok;
	// format = rok + '-' + miesiac[mies] + '-' + selectday;
	format = rok + '-' + mies + '-' + selectday;	
/********************* KONIEC FORMATU DATY *********************/	
		
	frmpole.value = format;
}

// ukrywanie kalendarza bez wstawiania daty
function exitKal()
{
	if(ns6 || ie)
		document.getElementById('kalendarz').style.visibility = 'hidden';
}

// ustawianie nowej daty po zmianie miesiaca lub roku
function setData()
{
	mies = document.forms['sdata'].elements['month'].value;
	rok = document.forms['sdata'].elements['year'].value;
	
	data = new Date(rok, mies, 1);
	mies = data.getMonth();
	rok = data.getFullYear();
	dzien = data.getDate();
	dzientyg = data.getDay();
	dniMies();
	rysujKal();
}

// rysowanie kalendarza
function rysujKal()
{
	kaltxt = '<form name="sdata" onSubmit="return false;">';
	kaltxt += '<table border=0 cellpadding=0 cellspacing=2 style="border:'+kol[3]+' 2px solid;background-color:'+kol[0]+';">';
	kaltxt += '<tr class=dzien><td colspan=6 height=25><select name="month" class="lista" onChange="setData()">';		

	// rysowanie miesięcy
	for (i=0; i<12; i++) {
		if(i==mies)
			kaltxt += '<option value="'+i+'" selected>'+miesiac[i]+'</option>';
		else
			kaltxt += '<option value="'+i+'">'+miesiac[i]+'</option>';
	}
	kaltxt += '</select>&nbsp;<select name="year" class="lista" onChange="setData()">';
	
	// rysowanie lat
	for(i=rokOd; i<=rokDo; i++) {
		if(i==rok)
			kaltxt += '<option value="'+i+'" selected>'+i+'</option>';
		else
			kaltxt += '<option value="'+i+'">'+i+'</option>';	
	}
	kaltxt += '</select>';
	kaltxt += '</td><td><a href="javascript:exitKal()" class="aktday">&nbsp;X&nbsp;</a></td></tr>';
	kaltxt += '<tr class=dnityg>';

	// rysowanie nazw dni tygodnia
	for (i=0; i<7; i++) {
		dayIndex = (pierwszyDzien + i) %7;  
		kaltxt += '<td width=30>' + dniTygodnia[dayIndex] + '</td>'; 
	}
  
	kaltxt += '</tr><tr class=dzien>';
	
	// rysowanie dni
	day = 1;
	for(i=0; day<=dni[mies]; i++)	{
		weekDay = (pierwszyDzien + i)%7;

//    	debugDate = '[' + rok + '|' + mies + '|' + dzien + '|' + dzientyg + ']'; 
//    	debug = '<span style="color:red;font-size:8px">' + i + '(' + dniTygodnia[weekDay] + ')' + debugDate + '</span>';
		debug = '';

    	roznica = (dzientyg - pierwszyDzien);
	   	if (i < ((roznica < 0) ? 7 + roznica: roznica)) {
			kaltxt += '<td>' + debug + '</td>';
		} else {
			if(day==adzien && rok==arok && mies==amies)
				kaltxt += '<td class=aktday><a class=aktday href="javascript:selectday='+day+';hideKal();" >'+day+debug+'</a></td>';
			else if(weekDay==0)
				kaltxt += '<td class=niedz><a class=niedz href="javascript:selectday='+day+';hideKal();" >'+day+debug+'</a></td>';
			else
				kaltxt += '<td><a class=dzien href="javascript:selectday='+day+';hideKal();" >'+day+debug+'</a></td>';
			if(i%7==6)
				kaltxt += '</tr><tr class=dzien>';
			day++;
		}
	}
	kaltxt += '</tr></table></form>';
	
	document.getElementById("kalendarz").innerHTML = kaltxt;
}

// style kalendarza i warstwa, na której się znajduje
document.write('<div id="kalendarz" style="visibility:hidden;position:absolute;z-index:1"></div>');
document.write('<style type="text/css">');
document.write('.dzien{font-family:Verdana;font-size:11px;color:'+kol[3]+';text-align:center;background-color:'+kol[1]+';text-decoration:none}');
document.write('.niedz{font-family:Verdana;font-size:11px;color:'+kol[3]+';text-align:center;background-color:'+kol[2]+';text-decoration:none}');
document.write('.aktday{color:'+kol[0]+';font-weight:bold;text-align:center;background-color:'+kol[3]+';text-decoration:none}');
document.write('.dnityg{font-family:Verdana;font-size:11px;color:'+kol[0]+';text-align:center;background-color:'+kol[4]+';}');
document.write('.lista{font-family:Verdana;font-size:11px;color:'+kol[3]+';}</style>');

//-->